datablock WheeledVehicleSpring(BlockoSedanSpring)
{
	length = 0.3;
	force = 4000;
	damping = 600;
	antiSwayForce = 3;
	
};

datablock WheeledVehicleTire(BlockoSedanTire)
{
	shapeFile = "./multisedanwheeld.dts";

	mass = 10;
	radius = 1;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;	

	lateralForce = 18000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 14000;
	longitudinalDamping = 2000;
	longitudinalRelaxation = 0.01;
};

datablock DebrisData(BlockoSedanTireDebris)
{
	emitters = "JeepTireDebrisTrailEmitter";

	shapeFile = "./multisedanwheeld.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(BlockoSedanExplosion : vehicleExplosion)
{
	debris = BlockoSedanTireDebris;
	debrisNum = 4;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 40;
	debrisThetaMax = 85;
	debrisVelocity = 14;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(BlockoSedanExplosionProjectile : vehicleExplosionProjectile)
{
	directDamage = 0;
	radiusDamage = 0;
	damageRadius = 0;
	explosion = BlockoSedanExplosion;

	directDamageType  = $DamageType::VehicleExplosion;
	radiusDamageType  = $DamageType::VehicleExplosion;

	explodeOnDeath = 1;

	armingDelay = 0;
	lifetime = 0;

	uiName = "";
};

datablock DebrisData(BlockoSedanDebris)
{
	emitters = "JeepDebrisTrailEmitter";

	shapeFile = "./multisedanWreck.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(BlockoSedanFinalExplosion : vehicleFinalExplosion)
{
	debris = BlockoSedanDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(BlockoSedanFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage = 0;
   radiusDamage = 0;
   damageRadius = 0;
   explosion = BlockoSedanFinalExplosion;

   directDamageType = $DamageType::VehicleExplosion;
   radiusDamageType = $DamageType::VehicleExplosion;

   explodeOnDeath = 1;

   armingDelay = 0;
   lifetime = 0;

   uiName = "";
};

datablock ParticleData(BlockoSedanPoliceLightParticle)
{
	dragCoefficient = 0.0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 1;
	lifetimeVarianceMS = 0;
	framesPerSec = 1;
	textureName = "base/lighting/corona";
	colors[0] = "0.000000 0.000000 1.000000 1.000000";
	colors[1] = "0.000000 0.000000 1.000000 1.000000";
	colors[2] = "0.000000 0.000000 1.000000 1.000000";
	colors[3] = "0.000000 0.000000 1.000000 1.000000";
	sizes[0] = "0.0";
	sizes[1] = "0.0";
	sizes[2] = "0.0";
	sizes[3] = "2.0";
	times[0] = "0.0";
	times[1] = "0.0";
	times[2] = "0.0";
	times[3] = "0.0";
};

datablock ParticleEmitterData(BlockoSedanPoliceLightEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvances = false;
	particles = "BlockoSedanPoliceLightParticle";
};

datablock ShapeBaseImageData(BlockoSedanPoliceLightAImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 4;
	rotation = "0.0 0.0 0.0";
	offset = "0.0 0.0 0.0";

	stateName[0] = "Ready";
	stateEmitter[0] = BlockoSedanPoliceLightEmitter;
	stateEmitterTime[0] = 10000;
};

datablock ShapeBaseImageData(BlockoSedanPoliceLightBImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 5;
	rotation = "0.0 0.0 0.0";
	offset = "0.0 0.0 0.0";

	stateName[0] = "Ready";
	stateEmitter[0] = BlockoSedanPoliceLightEmitter;
	stateEmitterTime[0] = 10000;
};

datablock WheeledVehicleData(BlockoSedanVehicle)
{
	category = "Vehicles";

	//- Render -
	shapeFile = "./multisedanI.dts";
	emap = true;

	//- Physics -
	mass = 300;
	drag = 1.6;
	density = 5.0;

	//- Damage/Energy -
	maxEnergy = 100;
	maxDamage = 200;
	destroyedLevel = 200;
	isInvincible = false;

	//- Camera -
	useEyePoint = false;

	//- Vehicle Data -
	jetForce = 3000.0;
	jetEnergyDrain = 2.0;
	minJetEnergy = 30.0;
	massCenter = "0.0 0.35 0.0";
	massBox = "0.0 0.0 0.0";
	bodyRestitution = 0.6;
	bodyFriction = 0.6;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	minImpactSpeed = 10.0;
	softImpactSpeed = 10.0;
	hardImpactSpeed = 15.0;
	maxSteeringAngle = 0.9785;
	integration = 4;
	collisionTol = 0.1;
	contactTol = 0.01;
	cameraRoll = false;
	cameraLag = 0.0;
	cameraDecay = 0.75;
	cameraOffset = 7.5;
	cameraMaxDist = 10.0;
	cameraTilt = 0.4;
	damageEmitter[0] = vehicleBurnEmitter;
	damageEmitter[1] = vehicleBurnEmitter;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	damageLevelTolerance[1] = 1.0;
	numDmgEmitterAreas = 1.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.6;
	exitSplashSoundVelocity = 5.0;
	softSplashSoundVelocity = 0.0;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	uiName = "Blocko Sedan";
	rideAble = true;
	
	//- Wheeled Vehicle -
	maxWheelSpeed = 32.0;
	engineTorque = 10000.0;
	engineBrake = 4000.0;
	brakeTorque = 20000.0;
	rollForce =	900.0;
	yawForce = 600.0;
	pitchForce = 3000.0;
	rotationalDrag = 0.2;
	stallSpeed = 0.0;
	steeringUseAutoReturn = true;
	steeringAutoReturnRate = 0.9;
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.1;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	tireEmitter = vehicleTireEmitter;

	//- Mounting -
	minMountDist = 3;
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

	//- Vehicle Damage -
	speedDamageScale = 1.04;
	collDamageMultiplier = 0.02;
	collDamageThresholdVel = 20.0;

	//- Passenger Protection -
	protectPassengersBurn = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;

	//- RunOver -
	minRunOverSpeed = 4.0;
	runOverDamageScale = 8.0;
	runOverPushScale = 1.2;

	//- Misc -
	defaultTire	= BlockoSedanTire;
	defaultSpring = BlockoSedanSpring;
	numWheels = 4;
	paintable = true;
	initialExplosionProjectile = BlockoSedanExplosionProjectile;
	initialExplosionOffset = 0.0;
	finalExplosionProjectile = BlockoSedanFinalExplosionProjectile;
	finalExplosionOffset = 0.5;
	burnTime = 4000;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;
};

datablock WheeledVehicleData(BlockoSedanPoliceVehicle : BlockoSedanVehicle)
{
	//- Vehicle Data -
	uiName = "Blocko Sedan - Police";
	maxWheelSpeed = 40.0;
};

datablock WheeledVehicleData(BlockoSedanTaxiVehicle : BlockoSedanVehicle)
{
	//- Vehicle Data -
	uiName = "Blocko Sedan - Taxi";
};

function BlockoSedanPoliceSirenSO::addCar(%this,%obj)
{
	if(isObject(%obj))
		if(%obj.getDatablock() == BlockoSedanPoliceVehicle.getID())
			%this.car[%this.carCount++ - 1] = %obj;
	if(%this.carCount == 1)
		%this.loop();
}

function BlockoSedanPoliceSirenSO::removeCar(%this,%obj)
{
	for(%a = 0; %a < %this.carCount; %a++)
		if(%this.car[%a] == %obj)
			break;
	if(%a < %this.carCount)
		for(%b = %a; %b < %this.carCount; %b++)
			%this.car[%b] = %this.car[%b + 1];
}

function BlockoSedanPoliceSirenSO::loop(%this)
{
	cancel(%this.loop);
	
	if(%this.carCount > 0)
	{
		%this.state++;
		if(%this.state > 3)
			%this.state = 0;
		
		for(%a = 0; %a < %this.carCount; %a++)
		{
			if(!isObject(%this.car[%a]))
				%this.removeCar(%this.car[%a]);
			else
			{
				switch(%this.state)
				{
					case 0:
						%this.car[%a].unmountImage(1);
					case 1:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(BlockoSedanPoliceLightAImage,0);
					case 2:
						%this.car[%a].unmountImage(0);
					case 3:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(BlockoSedanPoliceLightBImage,0);
				}
			}
		}
		
		%this.loop = %this.schedule(250,loop);
	}
	else
		%this.schedule(0,delete);
}

function BlockoSedanVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxiacc);
	%this.hideNode(policeacc);
	%this.hideNode(sidepanel);
	
	parent::onAdd(%db,%this);
}

function BlockoSedanPoliceVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxiacc);
	%this.unhideNode(policeacc);
	%this.unhideNode(sidepanel);
	
	if(!isObject(BlockoSedanPoliceSirenSO))
		new ScriptObject(BlockoSedanPoliceSirenSO);
	BlockoSedanPoliceSirenSO.addCar(%this);
	
	parent::onAdd(%db,%this);
}

function BlockoSedanTaxiVehicle::onAdd(%db,%this)
{
	%this.unhideNode(taxiacc);
	%this.hideNode(policeacc);
	%this.hideNode(sidepanel);
	
	parent::onAdd(%db,%this);
}

package Vehicle_BlockoSedan
{
	function serverCmdLight(%client)
	{
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.player;
			%veh = %player.getControlObject();
			if(isObject(%veh))
				if(%veh.getDatablock() == BlockoSedanPoliceVehicle.getID())
				{
					%veh.useSiren = !%veh.useSiren;
					return "";
				}
		}
		parent::serverCmdLight(%client);
	}
	function Vehicle::setNodeColor(%this,%node,%color)
	{
		parent::setNodeColor(%this,%node,%color);
		if(%this.getDatablock() == BlockoSedanPoliceVehicle.getID() && %node $= "ALL")
		{
			%r = getWord(%color,0);
			%g = getWord(%color,1);
			%b = getWord(%color,2);
			%lowest = 1;
			for(%a = 0; %a < 3; %a++)
			{
				%val = getWord(%color,%a);
				if(%val > %highest)
					%highest = %val;
				if(%val < %lowest)
					%lowest = %val;
			}
			%average = atof(%r) + atof(%g) + atof(%b);
			%average /= 3;
			%sat = %highest - %lowest;
			if(%sat < 0.1 && %average > 0.25)
				%sidePanel = "0 0 0.5 1.0";
			else
				%sidePanel = "0.9 0.9 0.9 1.0";
			%this.setNodeColor("sidepanel",%sidePanel);
		}
	}
};
activatePackage(Vehicle_BlockoSedan);